data	SEGMENT

		array		dw 	20 dup(?)	;tablica uchwytow	
		separator 	db 	' '		;separator (domyslnie spacja)
		outuchwyt	dw	0		;uchwyt do pliku wyjsciowego
		iloscwej	dw	0		;licznik ilosci plikow wej
		ilosczamk	dw	0		;licznik ilosci plikow zamknietych
		namestart	dw	?		;poczatek nazwy pliku wej/wyj
		index		dw	0		;zmienna suzaca do iterowaniu po tablicy
		bufor		db	0		;bufor do czytania
		aktplik		dw	0		;plik, ktorym sie aktualnie zajmuje
		help		db 	"HELP: -i plikwej -o plikwyj -t separator Uwaga na odstepy! Separator nie moze pozostac bez argumentu!$"
		erroropinfo	db	"Blad przy otwieraniu pliku!$"
		errorcrinfo	db	"Blad przy tworzeniu pliku!$"
		errorrdinfo	db	"Blad przy czytaniu z pliku!$"
		errorwrinfo	db	"Blad przy pisaniu do pliku!$"
		errorclinfo	db	"Blad przy zamykaniu pliku!$"

data	ENDS

code	SEGMENT
start:  
	;#######LADUJEMY STOS#######
	mov	ax,seg stos1
	mov	ss,ax
	mov	sp,offset top
	;#######STOS JUZ JEST#######

	;#######LADUJEMY DANE#######
	mov 	bx,seg data		;ustawiamy segment danych
	mov 	es,bx
	;#######DANE JUZ SA#########

	;#######CZYTANIE LINII KOMEND#######
	mov	ah,62h
	int	21h
	mov	ds,bx

	xor	cx,cx			;czyszcze cx
	mov	cl,byte ptr ds:[80h]	;dlugosc linii komend
	mov	bx,81h			;poczatek linii komend

	czytanie:
		cmp	cx,0			;sprawdzam, czy w linii komend cos jest
		je	main

		dec	cx			;zmniejszam ilosc znakow
		inc	bx			;przesuwam sie w prawo
		cmp	byte ptr ds:[bx],' '	;sprawdzam, czy wskazywany znak jest spacja
		je	czytanie

		cmp	byte ptr ds:[bx],'-'	;sprawdzam, czy wskazywany znak to '-'
		jne	pomoc			;jesli to nie jest spacja lub myslnik, to wyswietlamy pomoc i exit

		
		parametry:			;czytanie parametrow
			dec	cx
			inc	bx

			parametr_i:
				cmp	byte ptr ds:[bx],'i'	;sprawdzam, czy parametr to -i
				je	plik_wej

			parametr_o:
				cmp	byte ptr ds:[bx],'o'	;sprawdzam, czy parametr to -o
				je	plik_wyj

			parametr_t:
				cmp	byte ptr ds:[bx],'t'	;sprawdzam, czy parametr to -t
				je	sep

			parametr_h:
				cmp	byte ptr ds:[bx],'h'	;sprawdzam, czy parametr to -h
				je	pomoc

	
		plik_wej:			;obsluga parametru -i (plik wejsciowy)
			
			cmp	cx,0			;sprawdzam, czy w linii komend cos jest
			je	pomoc
			dec	cx			;szukam poczatku nazwy pliku... zmniejszam ilosc znakow
			inc	bx			;przesuwam sie w prawo
			cmp	byte ptr ds:[bx],' '	;sprawdzam, czy wskazywany znak jest spacja
			je	plik_wej

			mov	word ptr es:[namestart],bx	;zapisuje poczatek nazwy pliku wejsciowego	

			next_in:
				cmp	cx,0			;jesli podano tylko pliki wej
				je	wklej0wej			
				dec	cx			;szukam...
				inc	bx			;...konca...
				cmp	byte ptr ds:[bx],' '	;..nazwy pliku
				jne	next_in
	
				wklej0wej:
					mov	byte ptr ds:[bx],0	;na koniec wklejam 0

				mov	ah,3dh				;numer funkcji - otwieranie pliku
				mov	dx,word ptr es:[namestart]	;poczatek nazwy pliku
				xor	al,al				;tryb dostepu - 0 - tylko do odczytu
				int	21h
				jc	error_open			;sprawdzamy czy nastapil blad
				push	bx				;bx na stos, zeby go nie straci
				mov	bx,word ptr es:[index]		;pod bx przypisuje tymczasowo wartos zmiennej index
				mov	word ptr es:[array+bx],ax	;zapisuje uchwyt w tablicy uchwytow
				pop	bx				;zwracam bx jego wczesniejsza wartos
				add	word ptr es:[index],2		;zwiekszam index, zeby wskazywal na nastepny element
				add	word ptr es:[iloscwej],1	;zwiekszam ilosc plikow wejsciowych o jeden

				jmp	czytanie		;sprawdzam dalej linie komend
	


		plik_wyj:			;obsuga parametru -o (plik wyjsciowy)

			cmp	cx,0			;sprawdzam, czy w linii komend cos jest
			je	pomoc
			dec	cx			;szukam poczatku nazwy pliku... zmniejszam ilosc znakow
			inc	bx			;przesuwam sie w prawo
			cmp	byte ptr ds:[bx],' '	;sprawdzam, czy wskazywany znak jest spacja
			je	plik_wyj

			mov	word ptr es:[namestart],bx	;zapisuje poczatek nazwy pliku wyjsciowego

			next_out:
				cmp	cx,0			;jesli nie podano separatora
				je	wklej0wyj
				dec	cx			;szukam...
				inc	bx			;...konca...
				cmp	byte ptr ds:[bx],' '	;..nazwy pliku
				jne	next_out
				
				wklej0wyj:
					mov	byte ptr ds:[bx],0	;na koniec wklejam 0
	
				mov	ah,3ch				;numer funkcji - utworzenie
				mov	dx,word ptr es:[namestart]	;poczatek nazwy pliku
				push	cx
				xor	cx,cx				;atrybuty - normalny plik
				int	21h
				jc	error_cr			;sprawdzamy, czy nastapil blad
				pop	cx
				mov	word ptr es:[outuchwyt],ax	;zapisuje uchwyt

				jmp	czytanie		;sprawdzam dalej linie komend



		sep:				;obsluga parametru -t (separator)

			cmp	cx,0			;sprawdzam, czy w linii komend cos jest
			je	pomoc

			dec	cx			;szukam separatora... zmniejszam ilosc znakow
			inc	bx			;przesuwam sie w prawo
			cmp	byte ptr ds:[bx],' '	;sprawdzam, czy wskazywany znak jest spacja
			je	sep						

			push	cx				;cx na stos, zeby go nie straci
			mov	cl,byte ptr ds:[bx]		;pod cx przypisuje tymczasowo to, na co wskazuje bx
			mov	byte ptr es:[separator],cl	;zapisuje separator
			pop	cx				;zwracam cx jego wczesniejsza wartos	
			dec	cx
			inc	bx
			jmp	czytanie			;sprawdzam dalej linie komend
	

	
		pomoc:				;obsluga parametru -h (help)
			mov	ax,seg help	;wczytujemy...
			mov	ds,ax		;...napis...
			mov	dx,offset help	;...help
			mov	ah,09h		;wypisujemy help na ekran
			int	21h
			jmp	wyjscie		;wychodzimy z programu

	;#######LINIA KOMEND PRZECZYTANA#######


	;#######GoWNA TREs PROGRAMU#######
	main:
		mov	ax,es
		mov	ds,ax
		mov	word ptr ds:[aktplik],1				;wskazuje na aktualnie obsugiwany plik

		mov	word ptr ds:[index],0				;zeruje index, zeby odnosil sie do poczatku tablicy uchwytow plikow wej
		cmp	word ptr ds:[outuchwyt],0			;czy podano plik wyjsciowy?
		je	na_ekran					;jak nie, to wypisuje na ekran

		;####ZAPIS DO PLIKU####
		do_pliku:

			czytaj:
				mov	ax,word ptr ds:[index]		;index tymczasowo pod ax
				cmp	word ptr ds:[array+ax],0	;czy plik juz nie zostal zamkniety (liczba mniejsza od 0 oznacza, ze tak)-jak tak, to nastepny plik
				jl	next
				czytajznak:
					mov	ax,word ptr ds:[index]		;tymczasowo pod ax przypisuje wartos zmiennej index
					mov	bx,word ptr ds:[array+ax]	;uchwyt do pliku
					mov	cx,1				;liczba bajtow do wczytania
					mov	dx,offset bufor			;adres bufora
					mov	ah,3Fh				;funkcja czytania
					int	21h
					jc	error_read			;jesli cos sie nie udao...
					
					cmp	ax,0				;jesli koniec pliku (nic nie odczytano)...
					je	eof				

					cmp	byte ptr ds:[bufor],13d		;jesli carriage return...
					je	czytajznak			;przejdz do nastepnego wiersza (czytaj dalej)
					cmp	byte ptr ds:[bufor],10d		;jesli ENTER...
					je	next				;przejdz do nastepnego pliku

				zapisz:
					mov	ah,40h				;funkcja zapisu
					mov	bx,word ptr ds:[outuchwyt]	;uchwyt do pliku
					mov	cx,1				;liczba bajtow do zapisania
					mov	dx,offset bufor			;adres bufora
					int	21h
					jc	error_write			;jesli cos sie nie udao...
					jmp	czytajznak			;czytaj nastepny znak

			next:

				mov	cx,word ptr ds:[aktplik]		;tymczasowo pod cx numer pliki, ktorym sie aktualnie zajmuje
				cmp	cx,word ptr ds:[iloscwej]		;czy to wszystkie pliki w tej iteracji?
				jne	niewszystkie
				
				wszystkie:
					mov	ax,word ptr ds:[ilosczamk]	;tymczasowo pod ax przypisuje wartos zmiennej ilosczamk
					cmp	ax,word ptr ds:[iloscwej]
					je	close_output			;jesli juz zamknieto wszystkie pliki, wychodzimy

					mov	ah,40h				;w pliku wyj przejdz do nastepnej linii
					mov	bx,word ptr ds:[outuchwyt]
					mov	cx,1
					mov	byte ptr ds:[bufor],13d		;do bufora przekaz carriage return
					mov	dx,offset bufor
					int	21h
					jc	error_write

					mov	ah,40h
					mov	bx,word ptr ds:[outuchwyt]
					mov	cx,1
					mov	byte ptr ds:[bufor],10d		;do bufora przekaz ENTER
					mov	dx,offset bufor
					int	21h
					jc	error_write

					mov	word ptr ds:[aktplik],1		;zacznij iteracje ponownie od pierwszego pliku
					mov	word ptr ds:[index],0		;index=0 (zaczynamy od pierwszego pliku)
					jmp	czytaj

				niewszystkie:
					mov	ah,40h				;dopisz separator
					mov	bx,word ptr ds:[outuchwyt]
					mov	cx,1
					mov	dx,offset separator
					int	21h
					jc	error_write

					add	word ptr ds:[aktplik],1		;przejdz do nastepnego pliku
					add	word ptr ds:[index],2		;do indexu dodaj 2 (przejdz do nastepnego pliku) (2, bo typ DW)
					jmp	czytaj

			eof:						;obsluga konca pliku
				add	word ptr ds:[ilosczamk],1	;zwieksz ilosc zamknietych plikow
				mov	ax,word ptr ds:[index]		;tymczasowo pod ax przypisuje wartos zmiennej index
				mov	bx,word ptr ds:[array+ax]	;uchwyt do pliku
				mov	ah,3eh				;numer funkcji - zamykanie pliku
				int	21h				;plik zamkniety
				jc	error_close			;sprawdzamy, czy nastapil blad
				mov	ax,word ptr ds:[index]		;tymczasowo pod ax przypisuje wartos zmiennej index
				mov	word ptr ds:[array+ax],-1	;pozbadz sie uchwytu (-1 oznacza, ze juz sie tym plikiem nie zajmujemy, juz go nie ma)
				jmp	next				;zajmij sie nastepnym plikiem

		;####KONIEC ZAPISU DO PLIKU####


		;####WYPISANIE NA EKRAN####
		na_ekran:
			na_ekran_czytaj:
				mov	ax,word ptr ds:[index]		;tymczasowo pod ax przypisuje wartos zmiennej index
				cmp	word ptr ds:[array+ax],0	;czy plik juz nie zostal zamkniety (liczba mniejsza od 0 oznacza, ze tak)-jak tak, to nastepny plik
				jl	na_ekran_next
				
				na_ekran_czytajznak:
					mov	ax,word ptr ds:[index]		;tymczasowo pod ax przypisuje wartos zmiennej index
					mov	bx,word ptr ds:[array+ax]	;uchwyt do pliku
					mov	cx,1				;liczba bajtow do wczytania
					mov	dx,offset bufor			;adres bufora
					mov	ah,3Fh				;funkcja czytania
					int	21h
					jc	error_read			;jesli cos sie nie udao...
					
					cmp	ax,0				;jesli koniec pliku (nic nie odczytano)...
					je	na_ekran_eof				

					cmp	byte ptr ds:[bufor],10d		;jesli ENTER...
					je	na_ekran_next			;przejdz do nastepnego pliku
					cmp	byte ptr ds:[bufor],13d		;jesli carriage return...
					je	na_ekran_czytajznak		;przejdz do nastepnego wiersza (czytaj dalej)

				wypisz:
					mov	dl,byte ptr ds:[bufor]
					mov	ah,02h
					int	21h
					jmp	na_ekran_czytajznak		;czytaj nastepny znak

			na_ekran_next:
				mov	cx,word ptr ds:[aktplik]	;tymczasowo pod cx
				cmp	cx,word ptr ds:[iloscwej]	;czy to wszystkie pliki?
				jne	na_ekran_niewszystkie
				
				na_ekran_wszystkie:
					mov	ax,word ptr ds:[ilosczamk]	;tymczasowo pod ax przypisuje wartos zmiennej ilosczamk
					cmp	ax,word ptr ds:[iloscwej]
					je	wyjscie				;jesli juz zamknieto wszystkie pliki, wychodzimy

					mov	dl,13d				;dodaj carriage return
					mov	ah,02h
					int	21h
					
					mov	dl,10d				;to wypisz ENTER
					mov	ah,02h
					int	21h

					mov	word ptr ds:[aktplik],1		;zacznij iteracje znow od pierwszego pliku
					mov	word ptr ds:[index],0		;index=0 (zaczynamy od pierwszego pliku)
					jmp	na_ekran_czytaj

				na_ekran_niewszystkie:
					mov	dl,byte ptr ds:[separator]	;wypisz separator	
					mov	ah,02h
					int	21h

					add	word ptr ds:[aktplik],1		;przejdz do nastepnego pliku
					add	word ptr ds:[index],2		;do indexu dodaj 2 (przejdz do nastepnego pliku) (2, bo typ DW)
					jmp	na_ekran_czytaj

			na_ekran_eof:				;obsluga konca pliku
				add	word ptr ds:[ilosczamk],1	;zwieksz ilosc zamknietych plikow
				mov	ax,word ptr ds:[index]		;tymczasowo pod ax przypisuje wartos zmiennej index
				mov	bx,word ptr ds:[array+ax]	;uchwyt do pliku
				mov	ah,3eh				;numer funkcji - zamykanie pliku
				int	21h				;plik zamkniety
				jc	error_close			;sprawdzamy, czy nastapil blad
				mov	ax,word ptr ds:[index]		;tymczasowo pod ax przypisuje wartos zmiennej index
				mov	word ptr ds:[array+ax],-1	;pozbadz sie uchwytu (-1 oznacza, ze juz sie tym plikiem nie zajmujemy, juz go nie ma)
				jmp	na_ekran_next			;zajmij sie nastepnym plikiem

		;####KONIEC WYPISANIA NA EKRAN####			

	;#######KONIEC GoWNEJ TREsCI PROGRAMU#######



	;#######ZAMYKANIE PLIKU WYJSCIOWEGO#######
	close_output:
		mov	ah,3eh				;numer funkcji - zamykanie pliku
		mov	bx,word ptr ds:[outuchwyt]	;uchwyt do pliku
		int	21h				;plik zamkniety
		jc	error_close			;sprawdzamy, czy nastapil blad
		jmp	wyjscie				;wychodzimy z programu
	;#######PLIK ZAMKNIeTY#######
	

	;#######OBSLUGA BeDoW#######
	error_open:
		mov	ax,seg erroropinfo	;wczytujemy...
		mov	ds,ax			;...napis...
		mov	dx,offset erroropinfo	;...erroropinfo
		mov	ah,09h			;wypisujemy napis na ekran
		int	21h
		jmp	wyjscie			;wychodzimy z programu

	error_cr:
		mov	ax,seg errorcrinfo	;wczytujemy...
		mov	ds,ax			;...napis...
		mov	dx,offset errorcrinfo	;...errorcrinfo
		mov	ah,09h			;wypisujemy napis na ekran
		int	21h
		jmp	wyjscie			;wychodzimy z programu

	error_read:
		mov	ax,seg errorrdinfo	;wczytujemy...
		mov	ds,ax			;...napis...
		mov	dx,offset errorrdinfo	;...errorrdinfo
		mov	ah,09h			;wypisujemy napis na ekran
		int	21h
		jmp	wyjscie			;wychodzimy z programu

	error_write:
		mov	ax,seg errorwrinfo	;wczytujemy...
		mov	ds,ax			;...napis...
		mov	dx,offset errorwrinfo	;...errorwrinfo
		mov	ah,09h			;wypisujemy napis na ekran
		int	21h
		jmp	wyjscie			;wychodzimy z programu

	error_close:
		mov	ax,seg errorclinfo	;wczytujemy...
		mov	ds,ax			;...napis...
		mov	dx,offset errorclinfo	;...errorclinfo
		mov	ah,09h			;wypisujemy napis na ekran
		int	21h
		jmp	wyjscie			;wychodzimy z programu	

	;#######EXIT#######
wyjscie:
	mov	ah,04ch		;zakoncz program...
	int	21h		;...przy pomocy funkcji 04ch przerwania 21h
	;#######EXIT#######


code	ENDS

stos1	SEGMENT STACK
	dw	5 dup(?)
top	dw	?
stos1	ENDS

END  start